/*
    LCD control routine header
*/
#ifndef LCDIO_HEADER
#  define LCDIO_HEADER

#include "lcd.inc"

unsigned char lcd_rd_data(void);
unsigned char lcd_rd_inst(void);
void lcd_wr_data(unsigned char);
void lcd_put_char(unsigned char);
void lcd_wr_inst(unsigned char);

void lcd_GetDisplay(void);
void lcd_ReleaseDisplay(void);
void lcd_PutHex(unsigned, unsigned char);
void lcd_PutHexWord(unsigned);
void lcd_PutHexByte(unsigned);
void lcd_PutHexChar(unsigned);
void lcd_EraseToEndOfLine(void);

#if defined(__IAR_SYSTEMS_ICC__)
  void lcd_putstr(char FLASH *);
  void lcd_PrintMessageAt(char FLASH *, unsigned char);
#else
  void lcd_putstr(const char *);
  void lcd_PrintMessageAt(const char *, unsigned char);
#endif

void lcd_4_init();

extern Mutex lcdmutex;

#define lcd_setcursor(A) lcd_wr_inst((A) | LCD_SET_DDRAM)

#endif  // LCD_HEADER

